<h1>CodeRunner</h1>
<div class="markdown"><p>You need to have something to capture the output. This is useful when you want to have examples or capture test output in the docs.</p>
<p>I think the simplest way to do this is to do the following👇</p>
<ul>
<li><p>Take a notebook. </p>
</li>
<li><p>Create a fake server, fake client etc.</p>
</li>
<li><p>Run the notebook cell by cell and update the notebook with the output.</p>
</li>
</ul>
<p>This is taken straight from Pluto&#39;s webserver code</p>
</div>
```
using PlutoTest
------
Output
------

```

## executecode

```
    notebook = Notebook([
        Cell("x = 1"),
        Cell("y = x"),
        Cell("f(x) = x + y"),
        Cell("f(4)"),
    
        Cell("""begin
            g(a) = x
            g(a,b) = y      
        end"""),
        Cell("g(6) + g(6,6)"),
    
        Cell("import Distributed"),
        Cell("Distributed.myid()"),
    ])
------
Output
------
Any["Notebook", Any[(:cells_dict, (Dict{Symbol, Any}(:prefix => "Dict{Base.UUID, Pluto.Cell}", :elements => Any[(("UUID(\"297f4040-0e3e-11ed-0650-39561e495cea\")", MIME type text/plain), (Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"297f4040-0e3e-11ed-0650-39561e495cea\")", MIME type text/plain)), (:code, ("\"begin\\n    g(a) = x\\n    g(a,b) = y      \\nend\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("nothing", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("0.0", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain)), (:has_pluto_hook_features, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "5b7305c79d4f4b3"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "bccbbc38fc8956a7"), MIME type application/vnd.pluto.tree+object)), (:logs, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Tuple{Int64, Any}[], :type => :Array, :prefix_short => "", :objectid => "79993d59f624574a"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("nothing", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "fda7535bfe405ce8"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "272d3c5fd14c32bf"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("99", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "744000b605cd5396"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "35e0b40070a4d314"), MIME type application/vnd.pluto.tree+object)), (("UUID(\"297f4040-0e3e-11ed-29d3-09518b668235\")", MIME type text/plain), (Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"297f4040-0e3e-11ed-29d3-09518b668235\")", MIME type text/plain)), (:code, ("\"g(6) + g(6,6)\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("nothing", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("0.0", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain)), (:has_pluto_hook_features, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "5b7305c79d4f4b3"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "f595e353ee1d7efc"), MIME type application/vnd.pluto.tree+object)), (:logs, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Tuple{Int64, Any}[], :type => :Array, :prefix_short => "", :objectid => "af88bb16e203336f"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("nothing", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "15837b24adf8b099"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "4a49eb581785935f"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("99", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "7f330f0b2f575cb7"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "b2b106e6ea4577c3"), MIME type application/vnd.pluto.tree+object)), (("UUID(\"297f4040-0e3e-11ed-10d9-918f8a9a11ce\")", MIME type text/plain), (Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"297f4040-0e3e-11ed-10d9-918f8a9a11ce\")", MIME type text/plain)), (:code, ("\"f(4)\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("nothing", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("0.0", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain)), (:has_pluto_hook_features, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "5b7305c79d4f4b3"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "5f69d97541c58635"), MIME type application/vnd.pluto.tree+object)), (:logs, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Tuple{Int64, Any}[], :type => :Array, :prefix_short => "", :objectid => "5736c635315f64e1"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("nothing", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "86c7a6d990812599"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "cfa6c8d6a23f6bf2"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("99", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "34bf1a8d10e87cc1"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "36f74d69f2d22443"), MIME type application/vnd.pluto.tree+object)), (("UUID(\"297f4040-0e3e-11ed-2628-ad5a1313cf64\")", MIME type text/plain), (Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"297f4040-0e3e-11ed-2628-ad5a1313cf64\")", MIME type text/plain)), (:code, ("\"Distributed.myid()\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("nothing", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("0.0", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain)), (:has_pluto_hook_features, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "5b7305c79d4f4b3"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "e60f67cacf1093fe"), MIME type application/vnd.pluto.tree+object)), (:logs, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Tuple{Int64, Any}[], :type => :Array, :prefix_short => "", :objectid => "9f4e9de2c18f068b"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("nothing", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "8e141ccb9f1a02f1"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "ba446755f77a98f5"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("99", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "1e9db388bd3315b4"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "529e169f2a1fa0b1"), MIME type application/vnd.pluto.tree+object)), (("UUID(\"297f4040-0e3e-11ed-25eb-351950934271\")", MIME type text/plain), (Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"297f4040-0e3e-11ed-25eb-351950934271\")", MIME type text/plain)), (:code, ("\"import Distributed\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("nothing", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("0.0", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain)), (:has_pluto_hook_features, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "5b7305c79d4f4b3"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "cd1532e09d1c277a"), MIME type application/vnd.pluto.tree+object)), (:logs, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Tuple{Int64, Any}[], :type => :Array, :prefix_short => "", :objectid => "5abb5b883868785b"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("nothing", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "6b504e285992618b"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "81ebf22406c9aa72"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("99", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "f3e00075dbb56f15"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "54728c472dc87f2d"), MIME type application/vnd.pluto.tree+object)), (("UUID(\"297e2ed0-0e3e-11ed-2ce5-e516119b6875\")", MIME type text/plain), (Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"297e2ed0-0e3e-11ed-2ce5-e516119b6875\")", MIME type text/plain)), (:code, ("\"x = 1\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("nothing", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("0.0", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain)), (:has_pluto_hook_features, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "5b7305c79d4f4b3"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "ebd66308db4c147a"), MIME type application/vnd.pluto.tree+object)), (:logs, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Tuple{Int64, Any}[], :type => :Array, :prefix_short => "", :objectid => "b92b75f375f638d8"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("nothing", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "1e665eafbfb96c47"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "bb5f3bac79ab28f6"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("99", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "59be7cf28fae0306"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "7bd029ddfc83d502"), MIME type application/vnd.pluto.tree+object)), (("UUID(\"297f4040-0e3e-11ed-3722-a31bc888229b\")", MIME type text/plain), (Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"297f4040-0e3e-11ed-3722-a31bc888229b\")", MIME type text/plain)), (:code, ("\"y = x\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("nothing", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("0.0", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain)), (:has_pluto_hook_features, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "5b7305c79d4f4b3"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "8cea6b7c9cc187e3"), MIME type application/vnd.pluto.tree+object)), (:logs, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Tuple{Int64, Any}[], :type => :Array, :prefix_short => "", :objectid => "e706ca12d0ff6032"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("nothing", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "e60bd32b4f045a9b"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "e15ec63c45af5809"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("99", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "8a703c4438a1ec4c"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "312fefd567435b3a"), MIME type application/vnd.pluto.tree+object)), (("UUID(\"297f4040-0e3e-11ed-3aaf-2dd9b80e3ad1\")", MIME type text/plain), (Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"297f4040-0e3e-11ed-3aaf-2dd9b80e3ad1\")", MIME type text/plain)), (:code, ("\"f(x) = x + y\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("nothing", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("0.0", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain)), (:has_pluto_hook_features, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "5b7305c79d4f4b3"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "440996790b04fc1d"), MIME type application/vnd.pluto.tree+object)), (:logs, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Tuple{Int64, Any}[], :type => :Array, :prefix_short => "", :objectid => "fee12ee400b42df4"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("nothing", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "eca76b5adc40aad2"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "3730c6597153632e"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("99", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "44b5e5a94128dbf8"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "83ad58168c3e3a5f"), MIME type application/vnd.pluto.tree+object))], :type => :Dict, :prefix_short => "Dict", :objectid => "8aebf2ef387fde99"), MIME type application/vnd.pluto.tree+object)), (:cell_order, (Dict{Symbol, Any}(:prefix => "Base.UUID", :elements => Tuple{Int64, Any}[(1, ("UUID(\"297e2ed0-0e3e-11ed-2ce5-e516119b6875\")", MIME type text/plain)), (2, ("UUID(\"297f4040-0e3e-11ed-3722-a31bc888229b\")", MIME type text/plain)), (3, ("UUID(\"297f4040-0e3e-11ed-3aaf-2dd9b80e3ad1\")", MIME type text/plain)), (4, ("UUID(\"297f4040-0e3e-11ed-10d9-918f8a9a11ce\")", MIME type text/plain)), (5, ("UUID(\"297f4040-0e3e-11ed-0650-39561e495cea\")", MIME type text/plain)), (6, ("UUID(\"297f4040-0e3e-11ed-29d3-09518b668235\")", MIME type text/plain)), (7, ("UUID(\"297f4040-0e3e-11ed-25eb-351950934271\")", MIME type text/plain)), (8, ("UUID(\"297f4040-0e3e-11ed-2628-ad5a1313cf64\")", MIME type text/plain))], :type => :Array, :prefix_short => "", :objectid => "5503ba1d55e8a052"), MIME type application/vnd.pluto.tree+object)), (:path, ("\"C:\\\\Users\\\\family\\\\.julia\\\\pluto_notebooks\\\\Small program.jl\"", MIME type text/plain)), (:notebook_id, ("UUID(\"298840f0-0e3e-11ed-1f2d-f91be6c7828b\")", MIME type text/plain)), (:topology, (Dict{Symbol, Any}(:prefix => "Pluto.NotebookTopology", :elements => Any[(:nodes, (Dict{Symbol, Any}(:prefix => "Pluto.ImmutableDefaultDict{Pluto.Cell, Pluto.ReactiveNode}", :elements => Any[], :type => :Dict, :prefix_short => "ImmutableDefaultDict", :objectid => "d91f1e12b85b9ec4"), MIME type application/vnd.pluto.tree+object)), (:codes, (Dict{Symbol, Any}(:prefix => "Pluto.ImmutableDefaultDict{Pluto.Cell, Pluto.ExprAnalysisCache}", :elements => Any[], :type => :Dict, :prefix_short => "ImmutableDefaultDict", :objectid => "badaca935d01da17"), MIME type application/vnd.pluto.tree+object)), (:cell_order, (Dict{Symbol, Any}(:prefix => "Pluto.ImmutableVector{Pluto.Cell}: ", :elements => Any[(1, (Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"297e2ed0-0e3e-11ed-2ce5-e516119b6875\")", MIME type text/plain)), (:code, ("\"x = 1\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("nothing", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("0.0", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain)), (:has_pluto_hook_features, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "5b7305c79d4f4b3"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "ebd66308db4c147a"), MIME type application/vnd.pluto.tree+object)), (:logs, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Tuple{Int64, Any}[], :type => :Array, :prefix_short => "", :objectid => "b92b75f375f638d8"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("nothing", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "1e665eafbfb96c47"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "bb5f3bac79ab28f6"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("99", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "59be7cf28fae0306"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "7bd029ddfc83d502"), MIME type application/vnd.pluto.tree+object)), (2, (Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"297f4040-0e3e-11ed-3722-a31bc888229b\")", MIME type text/plain)), (:code, ("\"y = x\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("nothing", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("0.0", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain)), (:has_pluto_hook_features, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "5b7305c79d4f4b3"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "8cea6b7c9cc187e3"), MIME type application/vnd.pluto.tree+object)), (:logs, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Tuple{Int64, Any}[], :type => :Array, :prefix_short => "", :objectid => "e706ca12d0ff6032"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("nothing", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "e60bd32b4f045a9b"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "e15ec63c45af5809"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("99", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "8a703c4438a1ec4c"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "312fefd567435b3a"), MIME type application/vnd.pluto.tree+object)), (3, (Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"297f4040-0e3e-11ed-3aaf-2dd9b80e3ad1\")", MIME type text/plain)), (:code, ("\"f(x) = x + y\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("nothing", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("0.0", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain)), (:has_pluto_hook_features, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "5b7305c79d4f4b3"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "440996790b04fc1d"), MIME type application/vnd.pluto.tree+object)), (:logs, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Tuple{Int64, Any}[], :type => :Array, :prefix_short => "", :objectid => "fee12ee400b42df4"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("nothing", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "eca76b5adc40aad2"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "3730c6597153632e"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("99", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "44b5e5a94128dbf8"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "83ad58168c3e3a5f"), MIME type application/vnd.pluto.tree+object)), (4, (Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"297f4040-0e3e-11ed-10d9-918f8a9a11ce\")", MIME type text/plain)), (:code, ("\"f(4)\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("nothing", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("0.0", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain)), (:has_pluto_hook_features, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "5b7305c79d4f4b3"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "5f69d97541c58635"), MIME type application/vnd.pluto.tree+object)), (:logs, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Tuple{Int64, Any}[], :type => :Array, :prefix_short => "", :objectid => "5736c635315f64e1"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("nothing", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "86c7a6d990812599"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "cfa6c8d6a23f6bf2"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("99", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "34bf1a8d10e87cc1"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "36f74d69f2d22443"), MIME type application/vnd.pluto.tree+object)), (5, (Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"297f4040-0e3e-11ed-0650-39561e495cea\")", MIME type text/plain)), (:code, ("\"begin\\n    g(a) = x\\n    g(a,b) = y      \\nend\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("nothing", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("0.0", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain)), (:has_pluto_hook_features, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "5b7305c79d4f4b3"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "bccbbc38fc8956a7"), MIME type application/vnd.pluto.tree+object)), (:logs, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Tuple{Int64, Any}[], :type => :Array, :prefix_short => "", :objectid => "79993d59f624574a"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("nothing", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "fda7535bfe405ce8"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "272d3c5fd14c32bf"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("99", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "744000b605cd5396"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "35e0b40070a4d314"), MIME type application/vnd.pluto.tree+object)), "more", (8, (Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"297f4040-0e3e-11ed-2628-ad5a1313cf64\")", MIME type text/plain)), (:code, ("\"Distributed.myid()\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("nothing", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("0.0", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain)), (:has_pluto_hook_features, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "5b7305c79d4f4b3"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "e60f67cacf1093fe"), MIME type application/vnd.pluto.tree+object)), (:logs, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Tuple{Int64, Any}[], :type => :Array, :prefix_short => "", :objectid => "9f4e9de2c18f068b"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("nothing", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "8e141ccb9f1a02f1"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "ba446755f77a98f5"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("99", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "1e9db388bd3315b4"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "529e169f2a1fa0b1"), MIME type application/vnd.pluto.tree+object))], :type => :Array, :prefix_short => "Pluto.ImmutableVector{Pluto.Cell}: ", :objectid => "6e7428a84c328f83"), MIME type application/vnd.pluto.tree+object)), (:unresolved_cells, (Dict{Symbol, Any}(:prefix => "Pluto.ImmutableSet{Pluto.Cell}", :elements => Any[], :type => :Set, :prefix_short => "ImmutableSet", :objectid => "54eba93b0e70c522"), MIME type application/vnd.pluto.tree+object))], :type => :struct, :prefix_short => "NotebookTopology", :objectid => "4e9ffe196d1e86b7"), MIME type application/vnd.pluto.tree+object)), (:_cached_topological_order, ("nothing", MIME type text/plain)), (:pendingupdates, ("Channel{Any}(1024) (empty)", MIME type text/plain)), (:executetoken, (Dict{Symbol, Any}(:prefix => "Pluto.Token", :elements => Any[(:c, ("Channel{Nothing}(1) (1 item available)", MIME type text/plain))], :type => :struct, :prefix_short => "Token", :objectid => "41067d16312467c7"), MIME type application/vnd.pluto.tree+object)), (:compiler_options, ("nothing", MIME type text/plain)), (:nbpkg_ctx, (Dict{Symbol, Any}(:prefix => "Pkg.Types.Context", :elements => Any[(:env, (Dict{Symbol, Any}(:prefix => "Pkg.Types.EnvCache", :elements => Any[(:env, ("\"C:\\\\Users\\\\family\\\\AppData\\\\Local\\\\Temp\\\\jl_FADDmD\\\\Project.toml\"", MIME type text/plain)), (:project_file, ("\"C:\\\\Users\\\\family\\\\AppData\\\\Local\\\\Temp\\\\jl_FADDmD\\\\Project.toml\"", MIME type text/plain)), (:manifest_file, ("\"C:\\\\Users\\\\family\\\\AppData\\\\Local\\\\Temp\\\\jl_FADDmD\\\\Manifest.toml\"", MIME type text/plain)), (:pkg, ("nothing", MIME type text/plain)), (:project, (Dict{Symbol, Any}(:prefix => "Pkg.Types.Project", :elements => Any[(:other, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "d8278a2a35d45f49"), MIME type application/vnd.pluto.tree+object)), (:name, ("nothing", MIME type text/plain)), (:uuid, ("nothing", MIME type text/plain)), (:version, ("nothing", MIME type text/plain)), (:manifest, ("nothing", MIME type text/plain)), (:deps, (Dict{Symbol, Any}(:prefix => "Dict{String, Base.UUID}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "ea09115459977029"), MIME type application/vnd.pluto.tree+object)), (:extras, (Dict{Symbol, Any}(:prefix => "Dict{String, Base.UUID}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "2135cd1f47f0e586"), MIME type application/vnd.pluto.tree+object)), (:targets, (Dict{Symbol, Any}(:prefix => "Dict{String, Vector{String}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "58eda418b760990c"), MIME type application/vnd.pluto.tree+object)), (:compat, (Dict{Symbol, Any}(:prefix => "Dict{String, String}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "dba27f520f99ea2"), MIME type application/vnd.pluto.tree+object))], :type => :struct, :prefix_short => "Project", :objectid => "e041c026c3fdfa3a"), MIME type application/vnd.pluto.tree+object)), (:manifest, (Dict{Symbol, Any}(:prefix => "Pkg.Types.Manifest", :elements => Any[(:julia_version, ("nothing", MIME type text/plain)), (:manifest_format, ("v\"1.0.0\"", MIME type text/plain)), (:deps, (Dict{Symbol, Any}(:prefix => "Dict{Base.UUID, Pkg.Types.PackageEntry}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "7198c659e8b6b94a"), MIME type application/vnd.pluto.tree+object)), (:other, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "cb1d3bce9bbfa302"), MIME type application/vnd.pluto.tree+object))], :type => :struct, :prefix_short => "Manifest", :objectid => "4c39cd009d999f98"), MIME type application/vnd.pluto.tree+object)), (:original_project, (Dict{Symbol, Any}(:prefix => "Pkg.Types.Project", :elements => Any[(:other, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "29dfd8835944d04e"), MIME type application/vnd.pluto.tree+object)), (:name, ("nothing", MIME type text/plain)), (:uuid, ("nothing", MIME type text/plain)), (:version, ("nothing", MIME type text/plain)), (:manifest, ("nothing", MIME type text/plain)), (:deps, (Dict{Symbol, Any}(:prefix => "Dict{String, Base.UUID}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "7b4a72187c1a06af"), MIME type application/vnd.pluto.tree+object)), (:extras, (Dict{Symbol, Any}(:prefix => "Dict{String, Base.UUID}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "e2678bd5ca5437b0"), MIME type application/vnd.pluto.tree+object)), (:targets, (Dict{Symbol, Any}(:prefix => "Dict{String, Vector{String}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "17d762323533e9fc"), MIME type application/vnd.pluto.tree+object)), (:compat, (Dict{Symbol, Any}(:prefix => "Dict{String, String}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "b70a472a7399b18a"), MIME type application/vnd.pluto.tree+object))], :type => :struct, :prefix_short => "Project", :objectid => "1fc01d1b42ea9f4a"), MIME type application/vnd.pluto.tree+object)), (:original_manifest, (Dict{Symbol, Any}(:prefix => "Pkg.Types.Manifest", :elements => Any[(:julia_version, ("nothing", MIME type text/plain)), (:manifest_format, ("v\"1.0.0\"", MIME type text/plain)), (:deps, (Dict{Symbol, Any}(:prefix => "Dict{Base.UUID, Pkg.Types.PackageEntry}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "c904edcf178f01cb"), MIME type application/vnd.pluto.tree+object)), (:other, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "16b3c292b2ec9d6d"), MIME type application/vnd.pluto.tree+object))], :type => :struct, :prefix_short => "Manifest", :objectid => "814e64b507c2d024"), MIME type application/vnd.pluto.tree+object)), (:uuids, (Dict{Symbol, Any}(:prefix => "Dict{String, Vector{Base.UUID}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "218b37e1489b9cee"), MIME type application/vnd.pluto.tree+object)), (:paths, (Dict{Symbol, Any}(:prefix => "Dict{Base.UUID, Vector{String}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "75401fb5700570b1"), MIME type application/vnd.pluto.tree+object)), (:names, (Dict{Symbol, Any}(:prefix => "Dict{Base.UUID, Vector{String}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "be9f61d402c3f3ed"), MIME type application/vnd.pluto.tree+object))], :type => :struct, :prefix_short => "EnvCache", :objectid => "6a46653957f72c21"), MIME type application/vnd.pluto.tree+object)), (:io, ("IOContext(Base.PipeEndpoint(Base.Libc.WindowsRawSocket(0xffffffffffffffff) closed, 0 bytes waiting))", MIME type text/plain)), (:use_libgit2_for_all_downloads, ("false", MIME type text/plain)), (:use_only_tarballs_for_downloads, ("false", MIME type text/plain)), (:num_concurrent_downloads, ("8", MIME type text/plain)), (:graph_verbose, ("false", MIME type text/plain)), (:julia_version, ("v\"1.6.3\"", MIME type text/plain)), (:status_io, ("nothing", MIME type text/plain)), (:parser, (Dict{Symbol, Any}(:prefix => "Base.TOML.Parser", :elements => Any[(:str, ("\"\"", MIME type text/plain)), (:current_char, ("'\\xff\\xff\\xff\\xff': Malformed UTF-8 (category Ma: Malformed, bad data)", MIME type text/plain)), (:pos, ("1", MIME type text/plain)), (:prevpos, ("1", MIME type text/plain)), (:column, ("1", MIME type text/plain)), (:line, ("1", MIME type text/plain)), (:marker, ("0", MIME type text/plain)), (:active_table, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "288d6281d69fdf13"), MIME type application/vnd.pluto.tree+object)), (:dotted_keys, (Dict{Symbol, Any}(:prefix => "String", :elements => Tuple{Int64, Any}[], :type => :Array, :prefix_short => "", :objectid => "5bebf69dbd5d062a"), MIME type application/vnd.pluto.tree+object)), (:chunks, (Dict{Symbol, Any}(:prefix => "UnitRange{Int64}", :elements => Tuple{Int64, Any}[], :type => :Array, :prefix_short => "", :objectid => "7401f951ed8910e6"), MIME type application/vnd.pluto.tree+object)), (:inline_tables, (Dict{Symbol, Any}(:prefix => "Base.IdSet{Dict{String, Any}}", :elements => Any[], :type => :Set, :prefix_short => "IdSet", :objectid => "c6386235825ccd20"), MIME type application/vnd.pluto.tree+object)), (:static_arrays, (Dict{Symbol, Any}(:prefix => "Base.IdSet{Any}", :elements => Any[], :type => :Set, :prefix_short => "IdSet", :objectid => "9dfeb109b1e9692d"), MIME type application/vnd.pluto.tree+object)), (:defined_tables, (Dict{Symbol, Any}(:prefix => "Base.IdSet{Dict{String, Any}}", :elements => Any[], :type => :Set, :prefix_short => "IdSet", :objectid => "37ff81ba65eb0cd8"), MIME type application/vnd.pluto.tree+object)), (:root, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "288d6281d69fdf13"), MIME type application/vnd.pluto.tree+object)), (:filepath, ("nothing", MIME type text/plain)), (:Dates, ("Dates", MIME type text/plain))], :type => :struct, :prefix_short => "Parser", :objectid => "a58772d84d329c3e"), MIME type application/vnd.pluto.tree+object))], :type => :struct, :prefix_short => "Context", :objectid => "e080b6ae4686775d"), MIME type application/vnd.pluto.tree+object)), (:nbpkg_ctx_instantiated, ("false", MIME type text/plain)), (:nbpkg_restart_recommended_msg, ("nothing", MIME type text/plain)), (:nbpkg_restart_required_msg, ("nothing", MIME type text/plain)), (:nbpkg_terminal_outputs, (Dict{Symbol, Any}(:prefix => "Dict{String, String}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "4b6025649c4557a0"), MIME type application/vnd.pluto.tree+object)), (:nbpkg_busy_packages, (Dict{Symbol, Any}(:prefix => "String", :elements => Tuple{Int64, Any}[], :type => :Array, :prefix_short => "", :objectid => "10d9142c27373588"), MIME type application/vnd.pluto.tree+object)), (:nbpkg_installed_versions_cache, (Dict{Symbol, Any}(:prefix => "Dict{String, String}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "56a666c632d1deeb"), MIME type application/vnd.pluto.tree+object)), (:process_status, ("\"starting\"", MIME type text/plain)), (:wants_to_interrupt, ("false", MIME type text/plain)), (:last_save_time, ("1.658989566938e9", MIME type text/plain)), (:last_hot_reload_time, ("0.0", MIME type text/plain)), (:bonds, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Pluto.BondValue}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "4c345fae9c8ecfd8"), MIME type application/vnd.pluto.tree+object))], :struct, "Notebook", "53b544a4c2915b19"]
```

```
nb=executecode(notebook)
------
Output
------
Any["Notebook", Any[(:cells_dict, (Dict{Symbol, Any}(:prefix => "Dict{Base.UUID, Pluto.Cell}", :elements => Any[(("UUID(\"297f4040-0e3e-11ed-0650-39561e495cea\")", MIME type text/plain), (Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"297f4040-0e3e-11ed-0650-39561e495cea\")", MIME type text/plain)), (:code, ("\"begin\\n    g(a) = x\\n    g(a,b) = y      \\nend\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("\"g (generic function with 2 methods)\"", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("1.65899e9", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain)), (:has_pluto_hook_features, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "924eb5cfd9a208a9"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "2b43de12804e73ed"), MIME type application/vnd.pluto.tree+object)), (:logs, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Tuple{Int64, Any}[], :type => :Array, :prefix_short => "", :objectid => "feacfe33272426ef"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("0x000000000007b318", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "73b9c0db03e03f15"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "50cff4143d4c5af8"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("9", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "6bdb9582b8d67168"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "35e0b40070a4d314"), MIME type application/vnd.pluto.tree+object)), (("UUID(\"297f4040-0e3e-11ed-29d3-09518b668235\")", MIME type text/plain), (Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"297f4040-0e3e-11ed-29d3-09518b668235\")", MIME type text/plain)), (:code, ("\"g(6) + g(6,6)\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("\"2\"", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("1.65899e9", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain)), (:has_pluto_hook_features, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "25806cd2c715940a"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "57886382d8c9201d"), MIME type application/vnd.pluto.tree+object)), (:logs, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Tuple{Int64, Any}[], :type => :Array, :prefix_short => "", :objectid => "ef12693187eb779c"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("0x0000000000006914", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "5f1b1560d9cb9fcd"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "8d5bc848b64d09d4"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("9", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "c245f169fb8397ef"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "b2b106e6ea4577c3"), MIME type application/vnd.pluto.tree+object)), (("UUID(\"297f4040-0e3e-11ed-10d9-918f8a9a11ce\")", MIME type text/plain), (Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"297f4040-0e3e-11ed-10d9-918f8a9a11ce\")", MIME type text/plain)), (:code, ("\"f(4)\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("\"5\"", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("1.65899e9", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain)), (:has_pluto_hook_features, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "c694eaf29696a88d"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "9d7ba06a64c1810f"), MIME type application/vnd.pluto.tree+object)), (:logs, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Tuple{Int64, Any}[], :type => :Array, :prefix_short => "", :objectid => "5cb91e0a39d7962f"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("0x0000000000002ee0", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "d5da372c4749ffd6"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "b5df362c8753fccf"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("9", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "d60e21b464c958f9"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "36f74d69f2d22443"), MIME type application/vnd.pluto.tree+object)), (("UUID(\"297f4040-0e3e-11ed-2628-ad5a1313cf64\")", MIME type text/plain), (Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"297f4040-0e3e-11ed-2628-ad5a1313cf64\")", MIME type text/plain)), (:code, ("\"Distributed.myid()\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("\"6\"", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("1.65899e9", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain)), (:has_pluto_hook_features, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "d8fa031c29f48e83"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "b0700df3fb2262f"), MIME type application/vnd.pluto.tree+object)), (:logs, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Tuple{Int64, Any}[], :type => :Array, :prefix_short => "", :objectid => "ac95c65402d43f3a"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("0x000000000024e294", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "62f74f23e1844f97"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "6d013e3375982cae"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("9", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "6f58f7ab998c6a64"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "529e169f2a1fa0b1"), MIME type application/vnd.pluto.tree+object)), (("UUID(\"297f4040-0e3e-11ed-25eb-351950934271\")", MIME type text/plain), (Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"297f4040-0e3e-11ed-25eb-351950934271\")", MIME type text/plain)), (:code, ("\"import Distributed\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("\"\"", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("1.65899e9", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain)), (:has_pluto_hook_features, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "a160415d2953c6b0"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "f17584848c93d24e"), MIME type application/vnd.pluto.tree+object)), (:logs, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Tuple{Int64, Any}[], :type => :Array, :prefix_short => "", :objectid => "9c78a234e2a98a68"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("0x0000000000abe9c4", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "7a2731060fe40a03"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "506cbf403c6f20a4"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("9", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "c51fdbf8320e466f"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "54728c472dc87f2d"), MIME type application/vnd.pluto.tree+object)), (("UUID(\"297e2ed0-0e3e-11ed-2ce5-e516119b6875\")", MIME type text/plain), (Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"297e2ed0-0e3e-11ed-2ce5-e516119b6875\")", MIME type text/plain)), (:code, ("\"x = 1\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("\"1\"", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, (":x", MIME type text/plain)), (:last_run_timestamp, ("1.65899e9", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain)), (:has_pluto_hook_features, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "faa8abba421c2a3b"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "47b05bc62eae4088"), MIME type application/vnd.pluto.tree+object)), (:logs, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Tuple{Int64, Any}[], :type => :Array, :prefix_short => "", :objectid => "d94219ab57dd2ea4"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("0x00000000000078b4", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "d57f582ec696677b"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "104871ba3c2894c1"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("9", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "f99b7e45c2031fbe"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "7bd029ddfc83d502"), MIME type application/vnd.pluto.tree+object)), (("UUID(\"297f4040-0e3e-11ed-3722-a31bc888229b\")", MIME type text/plain), (Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"297f4040-0e3e-11ed-3722-a31bc888229b\")", MIME type text/plain)), (:code, ("\"y = x\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("\"1\"", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, (":y", MIME type text/plain)), (:last_run_timestamp, ("1.65899e9", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain)), (:has_pluto_hook_features, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "b3f9577b130b6f62"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "c210439b863a7ff4"), MIME type application/vnd.pluto.tree+object)), (:logs, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Tuple{Int64, Any}[], :type => :Array, :prefix_short => "", :objectid => "a28472fb637af365"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("0x0000000000003bc4", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "af2eaa3179f50149"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "e8610192ec59d87f"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("9", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "af96f93179f1710a"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "312fefd567435b3a"), MIME type application/vnd.pluto.tree+object)), (("UUID(\"297f4040-0e3e-11ed-3aaf-2dd9b80e3ad1\")", MIME type text/plain), (Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"297f4040-0e3e-11ed-3aaf-2dd9b80e3ad1\")", MIME type text/plain)), (:code, ("\"f(x) = x + y\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("\"f (generic function with 1 method)\"", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("1.65899e9", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain)), (:has_pluto_hook_features, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "8f113c936f5315d"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "77c6514271760fff"), MIME type application/vnd.pluto.tree+object)), (:logs, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Tuple{Int64, Any}[], :type => :Array, :prefix_short => "", :objectid => "d49f7cdaab5b9046"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("0x000000000004cdb0", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "48d162802d3a8bf0"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "f2f4dd0b9f65e1a"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("9", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "5afc4053f90dfe23"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "83ad58168c3e3a5f"), MIME type application/vnd.pluto.tree+object))], :type => :Dict, :prefix_short => "Dict", :objectid => "8aebf2ef387fde99"), MIME type application/vnd.pluto.tree+object)), (:cell_order, (Dict{Symbol, Any}(:prefix => "Base.UUID", :elements => Tuple{Int64, Any}[(1, ("UUID(\"297e2ed0-0e3e-11ed-2ce5-e516119b6875\")", MIME type text/plain)), (2, ("UUID(\"297f4040-0e3e-11ed-3722-a31bc888229b\")", MIME type text/plain)), (3, ("UUID(\"297f4040-0e3e-11ed-3aaf-2dd9b80e3ad1\")", MIME type text/plain)), (4, ("UUID(\"297f4040-0e3e-11ed-10d9-918f8a9a11ce\")", MIME type text/plain)), (5, ("UUID(\"297f4040-0e3e-11ed-0650-39561e495cea\")", MIME type text/plain)), (6, ("UUID(\"297f4040-0e3e-11ed-29d3-09518b668235\")", MIME type text/plain)), (7, ("UUID(\"297f4040-0e3e-11ed-25eb-351950934271\")", MIME type text/plain)), (8, ("UUID(\"297f4040-0e3e-11ed-2628-ad5a1313cf64\")", MIME type text/plain))], :type => :Array, :prefix_short => "", :objectid => "5503ba1d55e8a052"), MIME type application/vnd.pluto.tree+object)), (:path, ("\"C:\\\\Users\\\\family\\\\.julia\\\\pluto_notebooks\\\\Small program.jl\"", MIME type text/plain)), (:notebook_id, ("UUID(\"298840f0-0e3e-11ed-1f2d-f91be6c7828b\")", MIME type text/plain)), (:topology, (Dict{Symbol, Any}(:prefix => "Pluto.NotebookTopology", :elements => Any[(:nodes, (Dict{Symbol, Any}(:prefix => "Pluto.ImmutableDefaultDict{Pluto.Cell, Pluto.ReactiveNode}", :elements => Any[((Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"297e2ed0-0e3e-11ed-2ce5-e516119b6875\")", MIME type text/plain)), (:code, ("\"x = 1\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("\"1\"", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, (":x", MIME type text/plain)), (:last_run_timestamp, ("1.65899e9", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain)), (:has_pluto_hook_features, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "faa8abba421c2a3b"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "47b05bc62eae4088"), MIME type application/vnd.pluto.tree+object)), (:logs, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Tuple{Int64, Any}[], :type => :Array, :prefix_short => "", :objectid => "d94219ab57dd2ea4"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("0x00000000000078b4", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "d57f582ec696677b"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "104871ba3c2894c1"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("9", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "f99b7e45c2031fbe"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "7bd029ddfc83d502"), MIME type application/vnd.pluto.tree+object), (Dict{Symbol, Any}(:prefix => "ReactiveNode", :elements => Any[(:references, (Dict{Symbol, Any}(:prefix => "Set{Symbol}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "d3c727bb8a54a668"), MIME type application/vnd.pluto.tree+object)), (:definitions, (Dict{Symbol, Any}(:prefix => "Set{Symbol}", :elements => Any["more"], :type => :Set, :prefix_short => "Set", :objectid => "367dbe4a59d1c6c2"), MIME type application/vnd.pluto.tree+object)), (:soft_definitions, (Dict{Symbol, Any}(:prefix => "Set{Symbol}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "45c64a0e2b59c3f5"), MIME type application/vnd.pluto.tree+object)), (:funcdefs_with_signatures, (Dict{Symbol, Any}(:prefix => "Set{Pluto.ExpressionExplorer.FunctionNameSignaturePair}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "7f90bea5e4dd6ba8"), MIME type application/vnd.pluto.tree+object)), (:funcdefs_without_signatures, (Dict{Symbol, Any}(:prefix => "Set{Symbol}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "18717bc94bb88dbd"), MIME type application/vnd.pluto.tree+object)), (:macrocalls, (Dict{Symbol, Any}(:prefix => "Set{Symbol}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "fab6f6bdc43bfeeb"), MIME type application/vnd.pluto.tree+object))], :type => :struct, :prefix_short => "ReactiveNode", :objectid => "2de3855720e0e2e9"), MIME type application/vnd.pluto.tree+object)), ((Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"297f4040-0e3e-11ed-3aaf-2dd9b80e3ad1\")", MIME type text/plain)), (:code, ("\"f(x) = x + y\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("\"f (generic function with 1 method)\"", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("1.65899e9", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain)), (:has_pluto_hook_features, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "8f113c936f5315d"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "77c6514271760fff"), MIME type application/vnd.pluto.tree+object)), (:logs, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Tuple{Int64, Any}[], :type => :Array, :prefix_short => "", :objectid => "d49f7cdaab5b9046"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("0x000000000004cdb0", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "48d162802d3a8bf0"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "f2f4dd0b9f65e1a"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("9", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "5afc4053f90dfe23"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "83ad58168c3e3a5f"), MIME type application/vnd.pluto.tree+object), (Dict{Symbol, Any}(:prefix => "ReactiveNode", :elements => Any[(:references, (Dict{Symbol, Any}(:prefix => "Set{Symbol}", :elements => Any["more"], :type => :Set, :prefix_short => "Set", :objectid => "b650278e8344a3e8"), MIME type application/vnd.pluto.tree+object)), (:definitions, (Dict{Symbol, Any}(:prefix => "Set{Symbol}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "9c3fb20ad3d8fdf4"), MIME type application/vnd.pluto.tree+object)), (:soft_definitions, (Dict{Symbol, Any}(:prefix => "Set{Symbol}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "fae31c04aef19dd3"), MIME type application/vnd.pluto.tree+object)), (:funcdefs_with_signatures, (Dict{Symbol, Any}(:prefix => "Set{Pluto.ExpressionExplorer.FunctionNameSignaturePair}", :elements => Any["more"], :type => :Set, :prefix_short => "Set", :objectid => "524cad30bba0f329"), MIME type application/vnd.pluto.tree+object)), (:funcdefs_without_signatures, (Dict{Symbol, Any}(:prefix => "Set{Symbol}", :elements => Any["more"], :type => :Set, :prefix_short => "Set", :objectid => "5862b3b706da3c29"), MIME type application/vnd.pluto.tree+object)), (:macrocalls, (Dict{Symbol, Any}(:prefix => "Set{Symbol}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "416dd8ef5506e8a4"), MIME type application/vnd.pluto.tree+object))], :type => :struct, :prefix_short => "ReactiveNode", :objectid => "bc6c80b2067e4f7d"), MIME type application/vnd.pluto.tree+object)), ((Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"297f4040-0e3e-11ed-10d9-918f8a9a11ce\")", MIME type text/plain)), (:code, ("\"f(4)\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("\"5\"", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("1.65899e9", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain)), (:has_pluto_hook_features, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "c694eaf29696a88d"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "9d7ba06a64c1810f"), MIME type application/vnd.pluto.tree+object)), (:logs, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Tuple{Int64, Any}[], :type => :Array, :prefix_short => "", :objectid => "5cb91e0a39d7962f"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("0x0000000000002ee0", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "d5da372c4749ffd6"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "b5df362c8753fccf"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("9", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "d60e21b464c958f9"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "36f74d69f2d22443"), MIME type application/vnd.pluto.tree+object), (Dict{Symbol, Any}(:prefix => "ReactiveNode", :elements => Any[(:references, (Dict{Symbol, Any}(:prefix => "Set{Symbol}", :elements => Any["more"], :type => :Set, :prefix_short => "Set", :objectid => "a7b21a5c66c84cbd"), MIME type application/vnd.pluto.tree+object)), (:definitions, (Dict{Symbol, Any}(:prefix => "Set{Symbol}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "2160c4e8862b172b"), MIME type application/vnd.pluto.tree+object)), (:soft_definitions, (Dict{Symbol, Any}(:prefix => "Set{Symbol}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "c831a69703751c31"), MIME type application/vnd.pluto.tree+object)), (:funcdefs_with_signatures, (Dict{Symbol, Any}(:prefix => "Set{Pluto.ExpressionExplorer.FunctionNameSignaturePair}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "ab9c8cae84f6f057"), MIME type application/vnd.pluto.tree+object)), (:funcdefs_without_signatures, (Dict{Symbol, Any}(:prefix => "Set{Symbol}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "5fc715a48ae54a98"), MIME type application/vnd.pluto.tree+object)), (:macrocalls, (Dict{Symbol, Any}(:prefix => "Set{Symbol}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "e65b9653ebfd76f4"), MIME type application/vnd.pluto.tree+object))], :type => :struct, :prefix_short => "ReactiveNode", :objectid => "8c1c00b2fb6d1bc5"), MIME type application/vnd.pluto.tree+object)), ((Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"297f4040-0e3e-11ed-2628-ad5a1313cf64\")", MIME type text/plain)), (:code, ("\"Distributed.myid()\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("\"6\"", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("1.65899e9", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain)), (:has_pluto_hook_features, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "d8fa031c29f48e83"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "b0700df3fb2262f"), MIME type application/vnd.pluto.tree+object)), (:logs, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Tuple{Int64, Any}[], :type => :Array, :prefix_short => "", :objectid => "ac95c65402d43f3a"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("0x000000000024e294", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "62f74f23e1844f97"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "6d013e3375982cae"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("9", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "6f58f7ab998c6a64"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "529e169f2a1fa0b1"), MIME type application/vnd.pluto.tree+object), (Dict{Symbol, Any}(:prefix => "ReactiveNode", :elements => Any[(:references, (Dict{Symbol, Any}(:prefix => "Set{Symbol}", :elements => Any["more"], :type => :Set, :prefix_short => "Set", :objectid => "2af7c152295c5531"), MIME type application/vnd.pluto.tree+object)), (:definitions, (Dict{Symbol, Any}(:prefix => "Set{Symbol}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "d3fffa4972357746"), MIME type application/vnd.pluto.tree+object)), (:soft_definitions, (Dict{Symbol, Any}(:prefix => "Set{Symbol}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "d91562c4f58011ab"), MIME type application/vnd.pluto.tree+object)), (:funcdefs_with_signatures, (Dict{Symbol, Any}(:prefix => "Set{Pluto.ExpressionExplorer.FunctionNameSignaturePair}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "62b1f06ea8174153"), MIME type application/vnd.pluto.tree+object)), (:funcdefs_without_signatures, (Dict{Symbol, Any}(:prefix => "Set{Symbol}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "eccac6737f6b3617"), MIME type application/vnd.pluto.tree+object)), (:macrocalls, (Dict{Symbol, Any}(:prefix => "Set{Symbol}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "a0207ae39b786604"), MIME type application/vnd.pluto.tree+object))], :type => :struct, :prefix_short => "ReactiveNode", :objectid => "c459a7aafc3cdd59"), MIME type application/vnd.pluto.tree+object)), ((Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"297f4040-0e3e-11ed-25eb-351950934271\")", MIME type text/plain)), (:code, ("\"import Distributed\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("\"\"", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("1.65899e9", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain)), (:has_pluto_hook_features, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "a160415d2953c6b0"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "f17584848c93d24e"), MIME type application/vnd.pluto.tree+object)), (:logs, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Tuple{Int64, Any}[], :type => :Array, :prefix_short => "", :objectid => "9c78a234e2a98a68"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("0x0000000000abe9c4", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "7a2731060fe40a03"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "506cbf403c6f20a4"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("9", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "c51fdbf8320e466f"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "54728c472dc87f2d"), MIME type application/vnd.pluto.tree+object), (Dict{Symbol, Any}(:prefix => "ReactiveNode", :elements => Any[(:references, (Dict{Symbol, Any}(:prefix => "Set{Symbol}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "5e77f20b5572065b"), MIME type application/vnd.pluto.tree+object)), (:definitions, (Dict{Symbol, Any}(:prefix => "Set{Symbol}", :elements => Any["more"], :type => :Set, :prefix_short => "Set", :objectid => "bd39a63457c9ff14"), MIME type application/vnd.pluto.tree+object)), (:soft_definitions, (Dict{Symbol, Any}(:prefix => "Set{Symbol}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "73f0c73a0ad8a3ec"), MIME type application/vnd.pluto.tree+object)), (:funcdefs_with_signatures, (Dict{Symbol, Any}(:prefix => "Set{Pluto.ExpressionExplorer.FunctionNameSignaturePair}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "3fbc05fea39b4e33"), MIME type application/vnd.pluto.tree+object)), (:funcdefs_without_signatures, (Dict{Symbol, Any}(:prefix => "Set{Symbol}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "de0f041f8beff97b"), MIME type application/vnd.pluto.tree+object)), (:macrocalls, (Dict{Symbol, Any}(:prefix => "Set{Symbol}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "cd504d2d21abd0af"), MIME type application/vnd.pluto.tree+object))], :type => :struct, :prefix_short => "ReactiveNode", :objectid => "490836253ba50225"), MIME type application/vnd.pluto.tree+object)), ((Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"297f4040-0e3e-11ed-3722-a31bc888229b\")", MIME type text/plain)), (:code, ("\"y = x\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("\"1\"", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, (":y", MIME type text/plain)), (:last_run_timestamp, ("1.65899e9", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain)), (:has_pluto_hook_features, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "b3f9577b130b6f62"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "c210439b863a7ff4"), MIME type application/vnd.pluto.tree+object)), (:logs, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Tuple{Int64, Any}[], :type => :Array, :prefix_short => "", :objectid => "a28472fb637af365"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("0x0000000000003bc4", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "af2eaa3179f50149"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "e8610192ec59d87f"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("9", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "af96f93179f1710a"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "312fefd567435b3a"), MIME type application/vnd.pluto.tree+object), (Dict{Symbol, Any}(:prefix => "ReactiveNode", :elements => Any[(:references, (Dict{Symbol, Any}(:prefix => "Set{Symbol}", :elements => Any["more"], :type => :Set, :prefix_short => "Set", :objectid => "741a80716bb97aff"), MIME type application/vnd.pluto.tree+object)), (:definitions, (Dict{Symbol, Any}(:prefix => "Set{Symbol}", :elements => Any["more"], :type => :Set, :prefix_short => "Set", :objectid => "2c1f0549ed1ced4c"), MIME type application/vnd.pluto.tree+object)), (:soft_definitions, (Dict{Symbol, Any}(:prefix => "Set{Symbol}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "d19d0fe387aea7a"), MIME type application/vnd.pluto.tree+object)), (:funcdefs_with_signatures, (Dict{Symbol, Any}(:prefix => "Set{Pluto.ExpressionExplorer.FunctionNameSignaturePair}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "fc0fd275fc75d288"), MIME type application/vnd.pluto.tree+object)), (:funcdefs_without_signatures, (Dict{Symbol, Any}(:prefix => "Set{Symbol}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "ebc504206fcbdd82"), MIME type application/vnd.pluto.tree+object)), (:macrocalls, (Dict{Symbol, Any}(:prefix => "Set{Symbol}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "532e591e109a5c4e"), MIME type application/vnd.pluto.tree+object))], :type => :struct, :prefix_short => "ReactiveNode", :objectid => "38894a5695a8c850"), MIME type application/vnd.pluto.tree+object)), "more"], :type => :Dict, :prefix_short => "ImmutableDefaultDict", :objectid => "96c5bb049cb3d00f"), MIME type application/vnd.pluto.tree+object)), (:codes, (Dict{Symbol, Any}(:prefix => "Pluto.ImmutableDefaultDict{Pluto.Cell, Pluto.ExprAnalysisCache}", :elements => Any[((Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"297e2ed0-0e3e-11ed-2ce5-e516119b6875\")", MIME type text/plain)), (:code, ("\"x = 1\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("\"1\"", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, (":x", MIME type text/plain)), (:last_run_timestamp, ("1.65899e9", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain)), (:has_pluto_hook_features, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "faa8abba421c2a3b"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "47b05bc62eae4088"), MIME type application/vnd.pluto.tree+object)), (:logs, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Tuple{Int64, Any}[], :type => :Array, :prefix_short => "", :objectid => "d94219ab57dd2ea4"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("0x00000000000078b4", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "d57f582ec696677b"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "104871ba3c2894c1"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("9", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "f99b7e45c2031fbe"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "7bd029ddfc83d502"), MIME type application/vnd.pluto.tree+object), (Dict{Symbol, Any}(:prefix => "ExprAnalysisCache", :elements => Any[(:code, ("\"x = 1\"", MIME type text/plain)), (:parsedcode, (":(\$(Expr(:toplevel, :(#= C:\\Users\\family\\.julia\\pluto_notebooks\\Small program.jl#==#297e2ed0-0e3e-11ed-2ce5-e516119b6875:1 =#), :(x = 1))))", MIME type text/plain)), (:module_usings_imports, (Dict{Symbol, Any}(:prefix => "UsingsImports", :elements => Any[(:usings, (Dict{Symbol, Any}(:prefix => "Set{Expr}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "7d668b27f4c65315"), MIME type application/vnd.pluto.tree+object)), (:imports, (Dict{Symbol, Any}(:prefix => "Set{Expr}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "883047c0c7b4991"), MIME type application/vnd.pluto.tree+object))], :type => :struct, :prefix_short => "UsingsImports", :objectid => "3c0765568b5cfd9"), MIME type application/vnd.pluto.tree+object)), (:function_wrapped, ("true", MIME type text/plain)), (:forced_expr_id, ("nothing", MIME type text/plain))], :type => :struct, :prefix_short => "ExprAnalysisCache", :objectid => "c40c33b5dc8f38f6"), MIME type application/vnd.pluto.tree+object)), ((Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"297f4040-0e3e-11ed-3aaf-2dd9b80e3ad1\")", MIME type text/plain)), (:code, ("\"f(x) = x + y\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("\"f (generic function with 1 method)\"", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("1.65899e9", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain)), (:has_pluto_hook_features, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "8f113c936f5315d"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "77c6514271760fff"), MIME type application/vnd.pluto.tree+object)), (:logs, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Tuple{Int64, Any}[], :type => :Array, :prefix_short => "", :objectid => "d49f7cdaab5b9046"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("0x000000000004cdb0", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "48d162802d3a8bf0"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "f2f4dd0b9f65e1a"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("9", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "5afc4053f90dfe23"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "83ad58168c3e3a5f"), MIME type application/vnd.pluto.tree+object), (Dict{Symbol, Any}(:prefix => "ExprAnalysisCache", :elements => Any[(:code, ("\"f(x) = x + y\"", MIME type text/plain)), (:parsedcode, (":(\$(Expr(:toplevel, :(#= C:\\Users\\family\\.julia\\pluto_notebooks\\Small program.jl#==#297f4040-0e3e-11ed-3aaf-2dd9b80e3ad1:1 =#), :(f(x) = begin\n          #= C:\\Users\\family\\.julia\\pluto_notebooks\\Small program.jl#==#297f4040-0e3e-11ed-3aaf-2dd9b80e3ad1:1 =#\n          x + y\n      end))))", MIME type text/plain)), (:module_usings_imports, (Dict{Symbol, Any}(:prefix => "UsingsImports", :elements => Any[(:usings, (Dict{Symbol, Any}(:prefix => "Set{Expr}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "9fc8ae7bdd6d2d54"), MIME type application/vnd.pluto.tree+object)), (:imports, (Dict{Symbol, Any}(:prefix => "Set{Expr}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "5655800061c0fc42"), MIME type application/vnd.pluto.tree+object))], :type => :struct, :prefix_short => "UsingsImports", :objectid => "22c252decaebcb29"), MIME type application/vnd.pluto.tree+object)), (:function_wrapped, ("false", MIME type text/plain)), (:forced_expr_id, ("nothing", MIME type text/plain))], :type => :struct, :prefix_short => "ExprAnalysisCache", :objectid => "ddeb0f1a055b56e3"), MIME type application/vnd.pluto.tree+object)), ((Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"297f4040-0e3e-11ed-10d9-918f8a9a11ce\")", MIME type text/plain)), (:code, ("\"f(4)\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("\"5\"", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("1.65899e9", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain)), (:has_pluto_hook_features, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "c694eaf29696a88d"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "9d7ba06a64c1810f"), MIME type application/vnd.pluto.tree+object)), (:logs, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Tuple{Int64, Any}[], :type => :Array, :prefix_short => "", :objectid => "5cb91e0a39d7962f"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("0x0000000000002ee0", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "d5da372c4749ffd6"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "b5df362c8753fccf"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("9", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "d60e21b464c958f9"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "36f74d69f2d22443"), MIME type application/vnd.pluto.tree+object), (Dict{Symbol, Any}(:prefix => "ExprAnalysisCache", :elements => Any[(:code, ("\"f(4)\"", MIME type text/plain)), (:parsedcode, (":(\$(Expr(:toplevel, :(#= C:\\Users\\family\\.julia\\pluto_notebooks\\Small program.jl#==#297f4040-0e3e-11ed-10d9-918f8a9a11ce:1 =#), :(f(4)))))", MIME type text/plain)), (:module_usings_imports, (Dict{Symbol, Any}(:prefix => "UsingsImports", :elements => Any[(:usings, (Dict{Symbol, Any}(:prefix => "Set{Expr}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "f877b5e81cb6440b"), MIME type application/vnd.pluto.tree+object)), (:imports, (Dict{Symbol, Any}(:prefix => "Set{Expr}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "4f838e72cb41a99d"), MIME type application/vnd.pluto.tree+object))], :type => :struct, :prefix_short => "UsingsImports", :objectid => "3a8993bbaddb7bb2"), MIME type application/vnd.pluto.tree+object)), (:function_wrapped, ("true", MIME type text/plain)), (:forced_expr_id, ("nothing", MIME type text/plain))], :type => :struct, :prefix_short => "ExprAnalysisCache", :objectid => "cd716111f74b726f"), MIME type application/vnd.pluto.tree+object)), ((Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"297f4040-0e3e-11ed-2628-ad5a1313cf64\")", MIME type text/plain)), (:code, ("\"Distributed.myid()\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("\"6\"", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("1.65899e9", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain)), (:has_pluto_hook_features, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "d8fa031c29f48e83"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "b0700df3fb2262f"), MIME type application/vnd.pluto.tree+object)), (:logs, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Tuple{Int64, Any}[], :type => :Array, :prefix_short => "", :objectid => "ac95c65402d43f3a"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("0x000000000024e294", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "62f74f23e1844f97"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "6d013e3375982cae"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("9", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "6f58f7ab998c6a64"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "529e169f2a1fa0b1"), MIME type application/vnd.pluto.tree+object), (Dict{Symbol, Any}(:prefix => "ExprAnalysisCache", :elements => Any[(:code, ("\"Distributed.myid()\"", MIME type text/plain)), (:parsedcode, (":(\$(Expr(:toplevel, :(#= C:\\Users\\family\\.julia\\pluto_notebooks\\Small program.jl#==#297f4040-0e3e-11ed-2628-ad5a1313cf64:1 =#), :(Distributed.myid()))))", MIME type text/plain)), (:module_usings_imports, (Dict{Symbol, Any}(:prefix => "UsingsImports", :elements => Any[(:usings, (Dict{Symbol, Any}(:prefix => "Set{Expr}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "a1234efd843e2ba9"), MIME type application/vnd.pluto.tree+object)), (:imports, (Dict{Symbol, Any}(:prefix => "Set{Expr}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "c1b923fd51aad04f"), MIME type application/vnd.pluto.tree+object))], :type => :struct, :prefix_short => "UsingsImports", :objectid => "791ae4514912af39"), MIME type application/vnd.pluto.tree+object)), (:function_wrapped, ("true", MIME type text/plain)), (:forced_expr_id, ("nothing", MIME type text/plain))], :type => :struct, :prefix_short => "ExprAnalysisCache", :objectid => "ca7d8872efe4ffcb"), MIME type application/vnd.pluto.tree+object)), ((Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"297f4040-0e3e-11ed-25eb-351950934271\")", MIME type text/plain)), (:code, ("\"import Distributed\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("\"\"", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("1.65899e9", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain)), (:has_pluto_hook_features, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "a160415d2953c6b0"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "f17584848c93d24e"), MIME type application/vnd.pluto.tree+object)), (:logs, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Tuple{Int64, Any}[], :type => :Array, :prefix_short => "", :objectid => "9c78a234e2a98a68"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("0x0000000000abe9c4", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "7a2731060fe40a03"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "506cbf403c6f20a4"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("9", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "c51fdbf8320e466f"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "54728c472dc87f2d"), MIME type application/vnd.pluto.tree+object), (Dict{Symbol, Any}(:prefix => "ExprAnalysisCache", :elements => Any[(:code, ("\"import Distributed\"", MIME type text/plain)), (:parsedcode, (":(\$(Expr(:toplevel, :(#= C:\\Users\\family\\.julia\\pluto_notebooks\\Small program.jl#==#297f4040-0e3e-11ed-25eb-351950934271:1 =#), :(import Distributed))))", MIME type text/plain)), (:module_usings_imports, (Dict{Symbol, Any}(:prefix => "UsingsImports", :elements => Any[(:usings, (Dict{Symbol, Any}(:prefix => "Set{Expr}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "5357ed4157660ba5"), MIME type application/vnd.pluto.tree+object)), (:imports, (Dict{Symbol, Any}(:prefix => "Set{Expr}", :elements => Any["more"], :type => :Set, :prefix_short => "Set", :objectid => "235fdc8f2b8a47cf"), MIME type application/vnd.pluto.tree+object))], :type => :struct, :prefix_short => "UsingsImports", :objectid => "b9f1aae2bb3fde7e"), MIME type application/vnd.pluto.tree+object)), (:function_wrapped, ("false", MIME type text/plain)), (:forced_expr_id, ("nothing", MIME type text/plain))], :type => :struct, :prefix_short => "ExprAnalysisCache", :objectid => "6eb600efea654099"), MIME type application/vnd.pluto.tree+object)), ((Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"297f4040-0e3e-11ed-3722-a31bc888229b\")", MIME type text/plain)), (:code, ("\"y = x\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("\"1\"", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, (":y", MIME type text/plain)), (:last_run_timestamp, ("1.65899e9", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain)), (:has_pluto_hook_features, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "b3f9577b130b6f62"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "c210439b863a7ff4"), MIME type application/vnd.pluto.tree+object)), (:logs, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Tuple{Int64, Any}[], :type => :Array, :prefix_short => "", :objectid => "a28472fb637af365"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("0x0000000000003bc4", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "af2eaa3179f50149"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "e8610192ec59d87f"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("9", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "af96f93179f1710a"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "312fefd567435b3a"), MIME type application/vnd.pluto.tree+object), (Dict{Symbol, Any}(:prefix => "ExprAnalysisCache", :elements => Any[(:code, ("\"y = x\"", MIME type text/plain)), (:parsedcode, (":(\$(Expr(:toplevel, :(#= C:\\Users\\family\\.julia\\pluto_notebooks\\Small program.jl#==#297f4040-0e3e-11ed-3722-a31bc888229b:1 =#), :(y = x))))", MIME type text/plain)), (:module_usings_imports, (Dict{Symbol, Any}(:prefix => "UsingsImports", :elements => Any[(:usings, (Dict{Symbol, Any}(:prefix => "Set{Expr}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "523c7eca92d74877"), MIME type application/vnd.pluto.tree+object)), (:imports, (Dict{Symbol, Any}(:prefix => "Set{Expr}", :elements => Any[], :type => :Set, :prefix_short => "Set", :objectid => "79082241ff0fef34"), MIME type application/vnd.pluto.tree+object))], :type => :struct, :prefix_short => "UsingsImports", :objectid => "e9f927fd1a209c5f"), MIME type application/vnd.pluto.tree+object)), (:function_wrapped, ("true", MIME type text/plain)), (:forced_expr_id, ("nothing", MIME type text/plain))], :type => :struct, :prefix_short => "ExprAnalysisCache", :objectid => "a17b6b9fa50ab5bb"), MIME type application/vnd.pluto.tree+object)), "more"], :type => :Dict, :prefix_short => "ImmutableDefaultDict", :objectid => "81fc80301dac473a"), MIME type application/vnd.pluto.tree+object)), (:cell_order, (Dict{Symbol, Any}(:prefix => "Pluto.ImmutableVector{Pluto.Cell}: ", :elements => Any[(1, (Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"297e2ed0-0e3e-11ed-2ce5-e516119b6875\")", MIME type text/plain)), (:code, ("\"x = 1\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("\"1\"", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, (":x", MIME type text/plain)), (:last_run_timestamp, ("1.65899e9", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain)), (:has_pluto_hook_features, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "faa8abba421c2a3b"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "47b05bc62eae4088"), MIME type application/vnd.pluto.tree+object)), (:logs, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Tuple{Int64, Any}[], :type => :Array, :prefix_short => "", :objectid => "d94219ab57dd2ea4"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("0x00000000000078b4", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "d57f582ec696677b"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "104871ba3c2894c1"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("9", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "f99b7e45c2031fbe"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "7bd029ddfc83d502"), MIME type application/vnd.pluto.tree+object)), (2, (Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"297f4040-0e3e-11ed-3722-a31bc888229b\")", MIME type text/plain)), (:code, ("\"y = x\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("\"1\"", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, (":y", MIME type text/plain)), (:last_run_timestamp, ("1.65899e9", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain)), (:has_pluto_hook_features, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "b3f9577b130b6f62"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "c210439b863a7ff4"), MIME type application/vnd.pluto.tree+object)), (:logs, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Tuple{Int64, Any}[], :type => :Array, :prefix_short => "", :objectid => "a28472fb637af365"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("0x0000000000003bc4", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "af2eaa3179f50149"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "e8610192ec59d87f"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("9", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "af96f93179f1710a"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "312fefd567435b3a"), MIME type application/vnd.pluto.tree+object)), (3, (Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"297f4040-0e3e-11ed-3aaf-2dd9b80e3ad1\")", MIME type text/plain)), (:code, ("\"f(x) = x + y\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("\"f (generic function with 1 method)\"", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("1.65899e9", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain)), (:has_pluto_hook_features, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "8f113c936f5315d"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "77c6514271760fff"), MIME type application/vnd.pluto.tree+object)), (:logs, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Tuple{Int64, Any}[], :type => :Array, :prefix_short => "", :objectid => "d49f7cdaab5b9046"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("0x000000000004cdb0", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "48d162802d3a8bf0"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "f2f4dd0b9f65e1a"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("9", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "5afc4053f90dfe23"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "83ad58168c3e3a5f"), MIME type application/vnd.pluto.tree+object)), (4, (Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"297f4040-0e3e-11ed-10d9-918f8a9a11ce\")", MIME type text/plain)), (:code, ("\"f(4)\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("\"5\"", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("1.65899e9", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain)), (:has_pluto_hook_features, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "c694eaf29696a88d"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "9d7ba06a64c1810f"), MIME type application/vnd.pluto.tree+object)), (:logs, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Tuple{Int64, Any}[], :type => :Array, :prefix_short => "", :objectid => "5cb91e0a39d7962f"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("0x0000000000002ee0", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "d5da372c4749ffd6"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "b5df362c8753fccf"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("9", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "d60e21b464c958f9"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "36f74d69f2d22443"), MIME type application/vnd.pluto.tree+object)), (5, (Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"297f4040-0e3e-11ed-0650-39561e495cea\")", MIME type text/plain)), (:code, ("\"begin\\n    g(a) = x\\n    g(a,b) = y      \\nend\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("\"g (generic function with 2 methods)\"", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("1.65899e9", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain)), (:has_pluto_hook_features, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "924eb5cfd9a208a9"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "2b43de12804e73ed"), MIME type application/vnd.pluto.tree+object)), (:logs, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Tuple{Int64, Any}[], :type => :Array, :prefix_short => "", :objectid => "feacfe33272426ef"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("0x000000000007b318", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "73b9c0db03e03f15"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "50cff4143d4c5af8"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("9", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "6bdb9582b8d67168"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "35e0b40070a4d314"), MIME type application/vnd.pluto.tree+object)), "more", (8, (Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"297f4040-0e3e-11ed-2628-ad5a1313cf64\")", MIME type text/plain)), (:code, ("\"Distributed.myid()\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("\"6\"", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("1.65899e9", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain)), (:has_pluto_hook_features, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "d8fa031c29f48e83"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "b0700df3fb2262f"), MIME type application/vnd.pluto.tree+object)), (:logs, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Tuple{Int64, Any}[], :type => :Array, :prefix_short => "", :objectid => "ac95c65402d43f3a"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("0x000000000024e294", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "62f74f23e1844f97"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "6d013e3375982cae"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("9", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "6f58f7ab998c6a64"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "529e169f2a1fa0b1"), MIME type application/vnd.pluto.tree+object))], :type => :Array, :prefix_short => "Pluto.ImmutableVector{Pluto.Cell}: ", :objectid => "6e7428a84c328f83"), MIME type application/vnd.pluto.tree+object)), (:unresolved_cells, (Dict{Symbol, Any}(:prefix => "Pluto.ImmutableSet{Pluto.Cell}", :elements => Any[], :type => :Set, :prefix_short => "ImmutableSet", :objectid => "49dfc5a3aafbefe5"), MIME type application/vnd.pluto.tree+object))], :type => :struct, :prefix_short => "NotebookTopology", :objectid => "492f4549a584df08"), MIME type application/vnd.pluto.tree+object)), (:_cached_topological_order, (Dict{Symbol, Any}(:prefix => "Pluto.TopologicalOrder", :elements => Any[(:input_topology, (Dict{Symbol, Any}(:prefix => "Pluto.NotebookTopology", :elements => Any[(:nodes, (Dict{Symbol, Any}(:prefix => "Pluto.ImmutableDefaultDict{Pluto.Cell, Pluto.ReactiveNode}", :elements => Any["more"], :type => :Dict, :prefix_short => "ImmutableDefaultDict", :objectid => "96c5bb049cb3d00f"), MIME type application/vnd.pluto.tree+object)), (:codes, (Dict{Symbol, Any}(:prefix => "Pluto.ImmutableDefaultDict{Pluto.Cell, Pluto.ExprAnalysisCache}", :elements => Any["more"], :type => :Dict, :prefix_short => "ImmutableDefaultDict", :objectid => "81fc80301dac473a"), MIME type application/vnd.pluto.tree+object)), (:cell_order, (Dict{Symbol, Any}(:prefix => "Pluto.ImmutableVector{Pluto.Cell}: ", :elements => Any["more"], :type => :Array, :prefix_short => "Pluto.ImmutableVector{Pluto.Cell}: ", :objectid => "6e7428a84c328f83"), MIME type application/vnd.pluto.tree+object)), (:unresolved_cells, (Dict{Symbol, Any}(:prefix => "Pluto.ImmutableSet{Pluto.Cell}", :elements => Any[], :type => :Set, :prefix_short => "ImmutableSet", :objectid => "49dfc5a3aafbefe5"), MIME type application/vnd.pluto.tree+object))], :type => :struct, :prefix_short => "NotebookTopology", :objectid => "492f4549a584df08"), MIME type application/vnd.pluto.tree+object)), (:runnable, (Dict{Symbol, Any}(:prefix => "Pluto.Cell", :elements => Any[(1, (Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"297e2ed0-0e3e-11ed-2ce5-e516119b6875\")", MIME type text/plain)), (:code, ("\"x = 1\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("\"1\"", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, (":x", MIME type text/plain)), (:last_run_timestamp, ("1.65899e9", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain)), (:has_pluto_hook_features, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "faa8abba421c2a3b"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "47b05bc62eae4088"), MIME type application/vnd.pluto.tree+object)), (:logs, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Tuple{Int64, Any}[], :type => :Array, :prefix_short => "", :objectid => "d94219ab57dd2ea4"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("0x00000000000078b4", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "d57f582ec696677b"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "104871ba3c2894c1"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("9", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "f99b7e45c2031fbe"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "7bd029ddfc83d502"), MIME type application/vnd.pluto.tree+object)), (2, (Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"297f4040-0e3e-11ed-3722-a31bc888229b\")", MIME type text/plain)), (:code, ("\"y = x\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("\"1\"", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, (":y", MIME type text/plain)), (:last_run_timestamp, ("1.65899e9", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain)), (:has_pluto_hook_features, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "b3f9577b130b6f62"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "c210439b863a7ff4"), MIME type application/vnd.pluto.tree+object)), (:logs, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Tuple{Int64, Any}[], :type => :Array, :prefix_short => "", :objectid => "a28472fb637af365"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("0x0000000000003bc4", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "af2eaa3179f50149"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "e8610192ec59d87f"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("9", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "af96f93179f1710a"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "312fefd567435b3a"), MIME type application/vnd.pluto.tree+object)), (3, (Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"297f4040-0e3e-11ed-3aaf-2dd9b80e3ad1\")", MIME type text/plain)), (:code, ("\"f(x) = x + y\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("\"f (generic function with 1 method)\"", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("1.65899e9", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain)), (:has_pluto_hook_features, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "8f113c936f5315d"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "77c6514271760fff"), MIME type application/vnd.pluto.tree+object)), (:logs, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Tuple{Int64, Any}[], :type => :Array, :prefix_short => "", :objectid => "d49f7cdaab5b9046"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("0x000000000004cdb0", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "48d162802d3a8bf0"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "f2f4dd0b9f65e1a"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("9", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "5afc4053f90dfe23"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "83ad58168c3e3a5f"), MIME type application/vnd.pluto.tree+object)), (4, (Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"297f4040-0e3e-11ed-10d9-918f8a9a11ce\")", MIME type text/plain)), (:code, ("\"f(4)\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("\"5\"", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("1.65899e9", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain)), (:has_pluto_hook_features, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "c694eaf29696a88d"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "9d7ba06a64c1810f"), MIME type application/vnd.pluto.tree+object)), (:logs, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Tuple{Int64, Any}[], :type => :Array, :prefix_short => "", :objectid => "5cb91e0a39d7962f"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("0x0000000000002ee0", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "d5da372c4749ffd6"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "b5df362c8753fccf"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("9", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "d60e21b464c958f9"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "36f74d69f2d22443"), MIME type application/vnd.pluto.tree+object)), (5, (Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"297f4040-0e3e-11ed-0650-39561e495cea\")", MIME type text/plain)), (:code, ("\"begin\\n    g(a) = x\\n    g(a,b) = y      \\nend\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("\"g (generic function with 2 methods)\"", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("1.65899e9", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain)), (:has_pluto_hook_features, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "924eb5cfd9a208a9"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "2b43de12804e73ed"), MIME type application/vnd.pluto.tree+object)), (:logs, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Tuple{Int64, Any}[], :type => :Array, :prefix_short => "", :objectid => "feacfe33272426ef"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("0x000000000007b318", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "73b9c0db03e03f15"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "50cff4143d4c5af8"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("9", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "6bdb9582b8d67168"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "35e0b40070a4d314"), MIME type application/vnd.pluto.tree+object)), "more", (8, (Dict{Symbol, Any}(:prefix => "Cell", :elements => Any[(:cell_id, ("UUID(\"297f4040-0e3e-11ed-2628-ad5a1313cf64\")", MIME type text/plain)), (:code, ("\"Distributed.myid()\"", MIME type text/plain)), (:code_folded, ("false", MIME type text/plain)), (:output, (Dict{Symbol, Any}(:prefix => "CellOutput", :elements => Any[(:body, ("\"6\"", MIME type text/plain)), (:mime, ("MIME type text/plain", MIME type text/plain)), (:rootassignee, ("nothing", MIME type text/plain)), (:last_run_timestamp, ("1.65899e9", MIME type text/plain)), (:persist_js_state, ("false", MIME type text/plain)), (:has_pluto_hook_features, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "CellOutput", :objectid => "d8fa031c29f48e83"), MIME type application/vnd.pluto.tree+object)), (:queued, ("false", MIME type text/plain)), (:running, ("false", MIME type text/plain)), (:published_objects, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "b0700df3fb2262f"), MIME type application/vnd.pluto.tree+object)), (:logs, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Tuple{Int64, Any}[], :type => :Array, :prefix_short => "", :objectid => "ac95c65402d43f3a"), MIME type application/vnd.pluto.tree+object)), (:errored, ("false", MIME type text/plain)), (:runtime, ("0x000000000024e294", MIME type text/plain)), (:cell_dependencies, (Dict{Symbol, Any}(:prefix => "CellDependencies{Cell}", :elements => Any[(:downstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "62f74f23e1844f97"), MIME type application/vnd.pluto.tree+object)), (:upstream_cells_map, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Vector{Pluto.Cell}}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "6d013e3375982cae"), MIME type application/vnd.pluto.tree+object)), (:precedence_heuristic, ("9", MIME type text/plain))], :type => :struct, :prefix_short => "CellDependencies", :objectid => "6f58f7ab998c6a64"), MIME type application/vnd.pluto.tree+object)), (:running_disabled, ("false", MIME type text/plain)), (:depends_on_disabled_cells, ("false", MIME type text/plain))], :type => :struct, :prefix_short => "Cell", :objectid => "529e169f2a1fa0b1"), MIME type application/vnd.pluto.tree+object))], :type => :Array, :prefix_short => "", :objectid => "9a6d710554df01e9"), MIME type application/vnd.pluto.tree+object)), (:errable, (Dict{Symbol, Any}(:prefix => "Dict{Pluto.Cell, Pluto.ReactivityError}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "4c1a028ab081c411"), MIME type application/vnd.pluto.tree+object))], :type => :struct, :prefix_short => "TopologicalOrder", :objectid => "677bbbb10df72cdd"), MIME type application/vnd.pluto.tree+object)), (:pendingupdates, ("Channel{Any}(1024) (empty)", MIME type text/plain)), (:executetoken, (Dict{Symbol, Any}(:prefix => "Pluto.Token", :elements => Any[(:c, ("Channel{Nothing}(1) (1 item available)", MIME type text/plain))], :type => :struct, :prefix_short => "Token", :objectid => "41067d16312467c7"), MIME type application/vnd.pluto.tree+object)), (:compiler_options, ("nothing", MIME type text/plain)), (:nbpkg_ctx, (Dict{Symbol, Any}(:prefix => "Pkg.Types.Context", :elements => Any[(:env, (Dict{Symbol, Any}(:prefix => "Pkg.Types.EnvCache", :elements => Any[(:env, ("\"C:\\\\Users\\\\family\\\\AppData\\\\Local\\\\Temp\\\\jl_FADDmD\\\\Project.toml\"", MIME type text/plain)), (:project_file, ("\"C:\\\\Users\\\\family\\\\AppData\\\\Local\\\\Temp\\\\jl_FADDmD\\\\Project.toml\"", MIME type text/plain)), (:manifest_file, ("\"C:\\\\Users\\\\family\\\\AppData\\\\Local\\\\Temp\\\\jl_FADDmD\\\\Manifest.toml\"", MIME type text/plain)), (:pkg, ("nothing", MIME type text/plain)), (:project, (Dict{Symbol, Any}(:prefix => "Pkg.Types.Project", :elements => Any[(:other, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "279b16067305cc21"), MIME type application/vnd.pluto.tree+object)), (:name, ("nothing", MIME type text/plain)), (:uuid, ("nothing", MIME type text/plain)), (:version, ("nothing", MIME type text/plain)), (:manifest, ("nothing", MIME type text/plain)), (:deps, (Dict{Symbol, Any}(:prefix => "Dict{String, Base.UUID}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "f623c6ab10170933"), MIME type application/vnd.pluto.tree+object)), (:extras, (Dict{Symbol, Any}(:prefix => "Dict{String, Base.UUID}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "fcd8de839d813600"), MIME type application/vnd.pluto.tree+object)), (:targets, (Dict{Symbol, Any}(:prefix => "Dict{String, Vector{String}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "57afb931532ef5ae"), MIME type application/vnd.pluto.tree+object)), (:compat, (Dict{Symbol, Any}(:prefix => "Dict{String, String}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "c685634bca01f12"), MIME type application/vnd.pluto.tree+object))], :type => :struct, :prefix_short => "Project", :objectid => "3e2a98761e0af5fc"), MIME type application/vnd.pluto.tree+object)), (:manifest, (Dict{Symbol, Any}(:prefix => "Pkg.Types.Manifest", :elements => Any[(:julia_version, ("nothing", MIME type text/plain)), (:manifest_format, ("v\"1.0.0\"", MIME type text/plain)), (:deps, (Dict{Symbol, Any}(:prefix => "Dict{Base.UUID, Pkg.Types.PackageEntry}", :elements => Any["more"], :type => :Dict, :prefix_short => "Dict", :objectid => "7467fc2feb04933a"), MIME type application/vnd.pluto.tree+object)), (:other, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "46e92d3f31a1904e"), MIME type application/vnd.pluto.tree+object))], :type => :struct, :prefix_short => "Manifest", :objectid => "d9f893335184ff08"), MIME type application/vnd.pluto.tree+object)), (:original_project, (Dict{Symbol, Any}(:prefix => "Pkg.Types.Project", :elements => Any[(:other, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "320a49cc0054c524"), MIME type application/vnd.pluto.tree+object)), (:name, ("nothing", MIME type text/plain)), (:uuid, ("nothing", MIME type text/plain)), (:version, ("nothing", MIME type text/plain)), (:manifest, ("nothing", MIME type text/plain)), (:deps, (Dict{Symbol, Any}(:prefix => "Dict{String, Base.UUID}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "1aaacc335195cc4f"), MIME type application/vnd.pluto.tree+object)), (:extras, (Dict{Symbol, Any}(:prefix => "Dict{String, Base.UUID}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "3d254e97968ad22b"), MIME type application/vnd.pluto.tree+object)), (:targets, (Dict{Symbol, Any}(:prefix => "Dict{String, Vector{String}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "afa35941fb86ed46"), MIME type application/vnd.pluto.tree+object)), (:compat, (Dict{Symbol, Any}(:prefix => "Dict{String, String}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "650f362be65ea827"), MIME type application/vnd.pluto.tree+object))], :type => :struct, :prefix_short => "Project", :objectid => "6f35723d543b7205"), MIME type application/vnd.pluto.tree+object)), (:original_manifest, (Dict{Symbol, Any}(:prefix => "Pkg.Types.Manifest", :elements => Any[(:julia_version, ("nothing", MIME type text/plain)), (:manifest_format, ("v\"1.0.0\"", MIME type text/plain)), (:deps, (Dict{Symbol, Any}(:prefix => "Dict{Base.UUID, Pkg.Types.PackageEntry}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "4cf5722fb62b228f"), MIME type application/vnd.pluto.tree+object)), (:other, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "5eddd42d59fe097e"), MIME type application/vnd.pluto.tree+object))], :type => :struct, :prefix_short => "Manifest", :objectid => "9f2c84ec3e5a86c2"), MIME type application/vnd.pluto.tree+object)), (:uuids, (Dict{Symbol, Any}(:prefix => "Dict{String, Vector{Base.UUID}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "5d07caa8dddc0fd1"), MIME type application/vnd.pluto.tree+object)), (:paths, (Dict{Symbol, Any}(:prefix => "Dict{Base.UUID, Vector{String}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "58dd82f255877e94"), MIME type application/vnd.pluto.tree+object)), (:names, (Dict{Symbol, Any}(:prefix => "Dict{Base.UUID, Vector{String}}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "e7a16043f30f3791"), MIME type application/vnd.pluto.tree+object))], :type => :struct, :prefix_short => "EnvCache", :objectid => "7818092211dc80ff"), MIME type application/vnd.pluto.tree+object)), (:io, ("IOContext(Base.PipeEndpoint(Base.Libc.WindowsRawSocket(0xffffffffffffffff) closed, 0 bytes waiting))", MIME type text/plain)), (:use_libgit2_for_all_downloads, ("false", MIME type text/plain)), (:use_only_tarballs_for_downloads, ("false", MIME type text/plain)), (:num_concurrent_downloads, ("8", MIME type text/plain)), (:graph_verbose, ("false", MIME type text/plain)), (:julia_version, ("v\"1.6.3\"", MIME type text/plain)), (:status_io, ("nothing", MIME type text/plain)), (:parser, (Dict{Symbol, Any}(:prefix => "Base.TOML.Parser", :elements => Any[(:str, ("\"\"", MIME type text/plain)), (:current_char, ("'\\xff\\xff\\xff\\xff': Malformed UTF-8 (category Ma: Malformed, bad data)", MIME type text/plain)), (:pos, ("1", MIME type text/plain)), (:prevpos, ("1", MIME type text/plain)), (:column, ("1", MIME type text/plain)), (:line, ("1", MIME type text/plain)), (:marker, ("0", MIME type text/plain)), (:active_table, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "4ab1bbcd392fc7ea"), MIME type application/vnd.pluto.tree+object)), (:dotted_keys, (Dict{Symbol, Any}(:prefix => "String", :elements => Tuple{Int64, Any}[], :type => :Array, :prefix_short => "", :objectid => "51e25f21c7910ca7"), MIME type application/vnd.pluto.tree+object)), (:chunks, (Dict{Symbol, Any}(:prefix => "UnitRange{Int64}", :elements => Tuple{Int64, Any}[], :type => :Array, :prefix_short => "", :objectid => "836015a52a8c76cd"), MIME type application/vnd.pluto.tree+object)), (:inline_tables, (Dict{Symbol, Any}(:prefix => "Base.IdSet{Dict{String, Any}}", :elements => Any[], :type => :Set, :prefix_short => "IdSet", :objectid => "ffcd9a2828c4ef35"), MIME type application/vnd.pluto.tree+object)), (:static_arrays, (Dict{Symbol, Any}(:prefix => "Base.IdSet{Any}", :elements => Any[], :type => :Set, :prefix_short => "IdSet", :objectid => "c12d1b7cab83f183"), MIME type application/vnd.pluto.tree+object)), (:defined_tables, (Dict{Symbol, Any}(:prefix => "Base.IdSet{Dict{String, Any}}", :elements => Any[], :type => :Set, :prefix_short => "IdSet", :objectid => "3219feeb8d5db6bb"), MIME type application/vnd.pluto.tree+object)), (:root, (Dict{Symbol, Any}(:prefix => "Dict{String, Any}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "4ab1bbcd392fc7ea"), MIME type application/vnd.pluto.tree+object)), (:filepath, ("nothing", MIME type text/plain)), (:Dates, ("Dates", MIME type text/plain))], :type => :struct, :prefix_short => "Parser", :objectid => "8a38ed5cbc6f4f0c"), MIME type application/vnd.pluto.tree+object))], :type => :struct, :prefix_short => "Context", :objectid => "6307c75b69dbd8a6"), MIME type application/vnd.pluto.tree+object)), (:nbpkg_ctx_instantiated, ("true", MIME type text/plain)), (:nbpkg_restart_recommended_msg, ("nothing", MIME type text/plain)), (:nbpkg_restart_required_msg, ("nothing", MIME type text/plain)), (:nbpkg_terminal_outputs, (Dict{Symbol, Any}(:prefix => "Dict{String, String}", :elements => Any[(("\"Distributed\"", MIME type text/plain), ("\"\\e[32m\\e[1m  No Changes\\e[22m\\e[39m to `C:\\\\Users\\\\family\\\\AppData\\\\Local\\\\Temp\\\\jl_FADDmD\\\\Project.toml`\\n\\e[32m\\e[1m  No Changes\\e[22m\\e[39m to `C:\\\\Users\\\\family\\\\AppData\\\\Local\\\\Temp\\\\jl_FADDmD\\\\Manifest.toml`\\n\\e[32m\\e[1mLoading\\e[22m\\e[39m packages...\\n\"", MIME type text/plain))], :type => :Dict, :prefix_short => "Dict", :objectid => "4b6025649c4557a0"), MIME type application/vnd.pluto.tree+object)), (:nbpkg_busy_packages, (Dict{Symbol, Any}(:prefix => "String", :elements => Tuple{Int64, Any}[], :type => :Array, :prefix_short => "", :objectid => "c965e775902cd86c"), MIME type application/vnd.pluto.tree+object)), (:nbpkg_installed_versions_cache, (Dict{Symbol, Any}(:prefix => "Dict{String, String}", :elements => Any[(("\"Distributed\"", MIME type text/plain), ("\"stdlib\"", MIME type text/plain))], :type => :Dict, :prefix_short => "Dict", :objectid => "55b68b00817d514"), MIME type application/vnd.pluto.tree+object)), (:process_status, ("\"ready\"", MIME type text/plain)), (:wants_to_interrupt, ("false", MIME type text/plain)), (:last_save_time, ("1.658989566938e9", MIME type text/plain)), (:last_hot_reload_time, ("0.0", MIME type text/plain)), (:bonds, (Dict{Symbol, Any}(:prefix => "Dict{Symbol, Pluto.BondValue}", :elements => Any[], :type => :Dict, :prefix_short => "Dict", :objectid => "4c345fae9c8ecfd8"), MIME type application/vnd.pluto.tree+object))], :struct, "Notebook", "53b544a4c2915b19"]
```

```
#noop
@test nb.cells[4].output.body == "5"
------
Output
------
 
```

> executecode(nb::Notebook)–> This function does the following
>
>   * Take a notebook.
>   * Create a fake server, fake client etc.
>   * Run the notebook cell by cell and update the notebook with the output.

 [source](https://github-link.vercel.app/api?ghUrl=https://github.com/sapal6/Nbdev.jl/blob/master/src/CodeRunner.jl&q=executecode)


